=== debian/changelog ===
rspamd (2.5-2ubuntu1) groovy; urgency=medium

  * debian/patches/gcc10-ftbfs.patch: fix ftbfs with gcc 10 due to
    missing C++ header include.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 16:51:53 -0700

rspamd (2.5-2build1) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:46:09 +0100

rspamd (2.5-2) unstable; urgency=medium

  [ Christian Göttsche ]
  * d/control: switch to compat level 13.
  * rspamd.triggers: activate on resolved paths for jquery and
    glyphicons-halflings-regular.ttf.
  * d/{control,rules}: use libunwind only on supported architectures
  * d/rules:
    + drop as-needed linker flag.
    + enable CMAKE_BUILD_WITH_INSTALL_RPATH.
      Make the build reproducible (Closes: #956120)
  * d/tests:
    + add test that we use existing and resolved paths in the dpkg triggers
    + try to adjust flaky autopkgtest runs

 -- Sebastien Badia <sbadia@debian.org>  Thu, 28 May 2020 11:06:51 +0200

rspamd (2.5-1) unstable; urgency=medium

  [ Sebastien Badia ]
  * d/control:
    + Switch to debhelper-compat and level 12
    + Bump to Standards-Version 4.5.0 (no changes needed)
  * New upstream version 2.5 (Closes: #948607)
  * d/patches:
    + Import upstream patch for license problem with ConvertUTF
    + Refresh patches and rename 001_fix-perl-sheeband

  [ Christian Göttsche ]
  * d/NEWS: rename to canonical name and fix version
  * d/control:
    + Set Rules-Requires-Root to no
    + Update build dependencies
    + Recommend redis-server
    + Add ${perl:Depends} to package rspamd
  * d/salsa-ci.yml: add standard salsa-ci configuration
  * d/gbp.conf: drop export-dir setting
  * d/watch: use official rspamd repository
  * d/rules:
    + Fix HYPERSCAN logic blocking systemd service (Closes: #950320)
    + Set asm flags to please blhc
  * d/copyright: Update according new upstream
  * d/patches: add patch to add version to shared libraries
  * rework handling of already packaged js files
  * d/tests: add configtest and rspamd_stats test

 -- Sebastien Badia <sbadia@debian.org>  Sun, 05 Apr 2020 21:11:22 +0200
