=== debian/tests/control ===
Tests: install configcheck rspamd-stats webui-dependencies
Depends: @, curl
Restrictions: needs-root
