=== contrib/kann/CMakeLists.txt ===
SET(LIBKANNSRC	kautodiff.c kann.c)

ADD_LIBRARY(rspamd-kann SHARED ${LIBKANNSRC})

IF(WITH_BLAS)
    MESSAGE(STATUS "Use openblas to accelerate kann")
    TARGET_LINK_LIBRARIES(rspamd-kann ${BLAS_REQUIRED_LIBRARIES})
ENDIF(WITH_BLAS)

INSTALL(TARGETS rspamd-kann LIBRARY DESTINATION ${RSPAMD_LIBDIR})
