=== contrib/lua-bit/CMakeLists.txt ===
SET(BITSRC bit.c)

SET(LIB_TYPE STATIC)
ADD_LIBRARY(rspamd-bit ${LIB_TYPE} ${BITSRC})
