=== contrib/xxhash/CMakeLists.txt ===
SET(XXHASHSRC xxhash.c)

ADD_LIBRARY(xxhash STATIC ${XXHASHSRC})

IF(ENABLE_FULL_DEBUG MATCHES "OFF")
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
	SET_TARGET_PROPERTIES(xxhash PROPERTIES COMPILE_FLAGS "-O3")
endif ()
ENDIF()
